"""Patch for DT_String and DT_Var Zope core modules"""

from DocumentTemplate import DT_String, DT_Var
from DocumentTemplate.DT_Util import ParseError

def parse_block(self, text, start, result, tagre,
                stag, sloc, sargs, scommand):

    start=self.skip_eol(text,start)

    blocks=[]
    tname=scommand.name
    sname=stag
    sstart=start
    sa=sargs
    # Determine if the tag wants dtml parsing
    parse_dtml = not hasattr(scommand, 'disable_dtml_block_parsing')

    while 1:
        mo = tagre.search(text,start)
        if mo is None: self.parse_error('No closing tag', stag, text, sloc)
        l = mo.start(0)

        try: tag, args, command, coname= self._parseTag(mo,scommand,sa)
        except ParseError, m:
            if parse_dtml: self.parse_error(m[0],m[1], text, l)
            else: start = l + 1 # Not parsing DTML: Skip malformed tags
        else:
            if command:
                start=l+len(tag)
                if hasattr(command, 'blockContinuations'):
                    # New open tag.  Need to find closing tag.
                    try: start=self.parse_close(text, start, tagre, tag, l,
                                                command, args)
                    except: 
                        if parse_dtml: raise
            else:
                # Either a continuation tag or an end tag   
                section=self.SubTemplate(sname)
                if parse_dtml:
                    section._v_blocks=section.blocks=self.parse(text[:l],sstart)
                else:
                    section.raw = text[sstart:l]

                section._v_cooked=None
                blocks.append((tname,sargs,section))

                start=self.skip_eol(text,l+len(tag))

                if coname:
                    tname=coname
                    sname=tag
                    sargs=args
                    sstart=start
                else:
                    try:
                        r=scommand(blocks)
                        if hasattr(r,'simple_form'): r=r.simple_form
                        result.append(r)
                    except ParseError, m:
                        self.parse_error(m[0],stag,text,l)

                    return start

DT_String.String.parse_block = parse_block

DT_Var.Comment.disable_dtml_block_parsing = 1

